$(function(){
	init();
	//初始化
	function init(){
		FastClick.attach(document.body);

		$(".splash-src-change").each(function() {
			var $this = $(this);
			var bianhao = $this.attr("bianhao");
			if(isIOS){
				$this.attr("name", "splashBig0" + bianhao + ".png");
				$this.attr("src", "../images/about/splash0" + bianhao + ".png");
			}
			else {
				$this.attr("name", "splashBig0" + bianhao + "_ard.png");
				$this.attr("src", "../images/about/splash0" + bianhao + "_ard.png");
			}
		});

		blindEvent(); //绑定事件

		swiperInit(); //swiper组件初始化

		refreshVersion(); //更新版本号
	}

	//swiper组件初始化
	function swiperInit(){
		var swiperMain = new Swiper('#swiperMain',{
			loop: true,
			effect : 'coverflow',
			slidesPerView: 2,
			centeredSlides: true,
			coverflow: {
	            rotate: 50,
	            stretch: 0,
	            depth: 300,
	            modifier: 1,
	            slideShadows : true
	        },
		});


		var parallaxScroll = new Swiper('.parallaxScroll',{
			direction: 'vertical',
            slidesPerView: 'auto',
            freeMode: true,
            parallax : true,
		});
		setTimeout(function(){
			var $container = $(".container");
			var height = $container.height();
			$container.parent().css('height', height);
			parallaxScroll.onResize();
			parallaxScroll.update();
			if(parallaxScroll.maxTranslate() == 0) {
				parallaxScroll.maxTranslate = function () { return -height + document.documentElement.clientHeight; };
				alert(parallaxScroll.maxTranslate())
			}
		}, 1000);
		
	}

	//绑定事件
	function blindEvent(){
		var nameList = [];
		$("#swiperMain img").each(function(){
			var name = $(this).attr("name");
			if(name) nameList.push(name);
		});
		$("#swiperMain").on("click", "img", function(e){
			e.stopPropagation();
			viewBigImg({"name": nameList, "showName": $(this).attr("name")});
		});
	}

	//更新版本号
	function refreshVersion(){
		try{
			if(appVersion){
				$(".version").html(appVersion);
			}
		}catch(e){}
	}
});

//接口转接调用
function bridge(funcName, jsonString, errorCallbackFun) {
    if(!funcName) return;
    try{ if(openBridgeFunList && !openBridgeFunList[funcName]) return; }catch(e){} //检查是否存在接口筛选列表，以决定是否执行接口
    jsonString = jsonString || "";
    console.log(jsonString);
    
    if (isIOS) {
        var jsonObj = {"action": funcName, "jsonString": jsonString};
        try{ window.webkit.messageHandlers.observe.postMessage(JSON.stringify(jsonObj)); }catch(e){
            if(errorCallbackFun) errorCallbackFun();
        }
    }
    else {
        try{
            if(jsonString){
                dictcn[funcName](jsonString);
            }
            else {
                dictcn[funcName]();
            }
        }catch(e){
            if(errorCallbackFun) errorCallbackFun();
        }
    }
}

// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}


/* 查看大图方法
 * viewBigImg方法参数：
 * {
 * "name": ["","",...] //当前面板中图片name数组
 * "showName": "" //标记显示数组中的哪个图片
 * "filePath": "" //图片存储路径
 * }
 */
  function viewBigImg(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var showName = jsonData.showName || "";
    var filePath = "/about/img/";
    bridge("viewBigImg", JSON.stringify({'name': name, 'showName': showName, "filePath": filePath}));
 }

  /* 开放给native接口：修改版本号
 * refreshAppVersion方法参数：
 * {
 * "version": "" //app版本号
 * }
 */
 function refreshAppVersion(jsonData) {
 	jsonData = parseJson(jsonData);
    var version = jsonData.version || "";
    $(".version").html(version);
 }