;(function($){
    var $adp,adper,args={},icon,loaded,delaytime;
    var isLoadingUrl=0; //标记播放器是否正在加载新音频
    var delayLoadUrl=0; //标记播放器是否应延时加载新音频
    var queuePlayOff = 0; //队列播放开关（冲突检测时用）
    $.fn.audioPlayer = function(options) {//Zepto.fn是一个对象,在这个对象添加一个方法，所有的Zepto对象上都能用到该方法。
        // stopPlay(); //如果正在播放，则停止播放和动画
        args = $.extend({}, $.fn.audioPlayer.defaults, options);//通过源对象扩展目标对象的属性，源对象属性将覆盖目标对象属性
        return this.each(function() {
            icon = this;
            if(isLoadingUrl){ //如果上一个音频没有加载完，则延迟加载新的音频
                delayLoadUrl = 1;
            }
            else {
                loadNewAudio();
            }
        });
    };
    //播放器记载新媒体方法
    function loadNewAudio(){
        adper.src = args.url;
        loaded = 0;
	    isLoadingUrl = 1;
        if(args.callbackType == 1){
            delaytime = 0;
        }
        adper.load();
    }
    // 默认参数
    $.fn.audioPlayer.defaults = {
        "url" : null, //音频路径
        "autoPlay": 0, //是否自动播放
        "callbackType": 0,
        "tracePlay": 0, //标记是否从队列播放接口传递过来的播放请求
        "startTime": 0, //开始播放时间
    };
    // 开放接口方法
    $.audioPlayer = ({
        play:function(){ //播放
            adper.play();
        },
        pause:function(){ //暂停
            adper.pause();
        },
        stopPlay:function(){ //音频播放事件冲突操作
            stopPlay();
        },
        emptyIcon:function(){ //清空icon对象
            icon = null;
        },
        playerPause:function(){ //播放器暂停调用方法
            playerPause();
        },
        ifAdpPaused:function(){ //播放器是否暂停
            return adper.paused;
        },
        playOrPause:function(){ //播放或暂停
            if(adper.paused){
                adper.play();
                return;
            }
            adper.pause();
        },
        autoPlay:function(a){ //是否自动播放
            args.autoPlay = a;
        },
        reLoad:function(){ //重新加载
            adper.load();
            loaded = 0;
        },
        getDelaytime:function(){ //返回delaytime的值
            return delaytime;
        },
        getProgress:function(){ //返回播放进度
            return adper.currentTime/adper.duration;
        },
        getCurrentTime:function(){
            return adper.currentTime;
        },
        setCurrentTime:function(time){
            if(time != null && time >= 0){
                adper.currentTime = time;
            }
        },
        getDuration:function(){
            return adper.duration;
        },
        isHandleMe:function(obj){ //是否正在处理我的请求
            return icon == obj;
        },
        getQueuePlayOff:function(){ //获取 queuePlayOff 的值
            return queuePlayOff;
        },
        setQueuePlayOff:function(a){ //设置 queuePlayOff 的值
            queuePlayOff = a;
        },
        getCallbackType:function(){ //获取 callbackType 的值
            return args.callbackType;
        },
        getArgTracePlay:function(){ //获取 args.tracePlay 的值
            return args.tracePlay;
        }
    });

    //初始化
    init();
    function init(){
        creatAudioPlayer(); //创建音频播放器
        audioEventListener(); //为播放器添加事件监听
    }
    //创建音频播放器
    function creatAudioPlayer(){
        var htmlText = '<audio src="./audio/demo.mp3" id="audioPlayer">您的浏览器不支持音频标签！</audio>';
        $('body').append(htmlText);
        $adp = $('#audioPlayer');
        adper = $adp[0];
        $(document).one("touchstart",function(e){ //无权限时，激活播放器
            if(!auth && !isIOS){
                adper.play();
            }
        });
    }
    //为播放器添加事件监听
    function audioEventListener(){
        $adp.on('canplay',function(){
            loaded = 1;
            isLoadingUrl = 0;
            if(delayLoadUrl){
                delayLoadUrl = 0;
                loadNewAudio();
                return;
            }
            if(queuePlayOff == 1 && args.tracePlay == 1){
                args.autoPlay = 0;
            }
            queuePlayOff = 0;
            if(args.autoPlay){
                args.autoPlay = 0;
                this.play();
            }
            if(args.callbackType == 1){
                //设置 delaytime，控制录音自动停止的延迟时间
                if(!delaytime){
                    delaytime = adper.duration * 2000;
                    if(delaytime > 100000){
                        if(adper.paused){
                            adper.currentTime = 0.01;
                            setTimeout(function(){
                                delaytime = adper.duration * 2000;
                            },200);
                        }
                        else {
                            setTimeout(function(){
                                delaytime = adper.duration * 2000;
                            },100);
                        }
                    }
                }
            }
            //如果开始时间有值，则跳到对应进度
            if(args.startTime) {
                if(this.duration){
                    adper.currentTime = args.startTime;
                    args.startTime = 0;
                }
                else{
                    adper.play();
                    adper.pause();
                    setTimeout(function(){
                        adper.currentTime = args.startTime;
                        args.startTime = 0;
                        adper.play();
                        adper.pause();
                        // alert(adper.currentTime)
                    }, 500);
                }
            }
        });
        $adp.on('playing',function(){
            console.log("playing--------");
            if(args.callbackType == 1){
                if(delaytime == 0){
                    setTimeout(function(){
                        delaytime = adper.duration * 2000;
                    },100);
                }
                $.iconAnimate.playSoundAniStart(icon);
            }
            else if(args.callbackType == 2){
                $.iconAnimate.listeningAniStart(icon);
            }
            else if(args.callbackType == 3){
                $.iconAnimate.dialoAniStart(icon);
            }
            else if(args.callbackType == 4){
                $.iconAnimate.lineAinStart(icon);
            }
            else if(args.callbackType == 5){
                $.iconAnimate.dictPlaySoundAinStart(icon);
            }
            else if(args.callbackType == 6){
                $.iconAnimate.dictlistenSoundAinStart(icon);
            }
        });
        $adp.on('pause',function(){
            playerPause();
        });
        $adp.on('ended',function(){
            if(args.callbackType == 1){
                $.iconAnimate.playSoundAniStop(icon);
                $.commFun.tracePlayQueue(icon);
            }
            else if(args.callbackType == 2){
                $.iconAnimate.listeningAniStop(icon);
            }
            else if(args.callbackType == 3){
                $.iconAnimate.dialoAniStop(icon);
            }
            else if(args.callbackType == 4){
                $.iconAnimate.lineAinStop(icon);
                $.commFun.frequentPlay(icon);
            }
            else if(args.callbackType == 5){
                $.iconAnimate.dictPlaySoundAinStop(icon);
                pubArgu.listenVoiceObj = null;
                icon = null;
            }
            else if(args.callbackType == 6){
                $.iconAnimate.dictlistenSoundAinStop(icon);
                pubArgu.listenVoiceObj = null;
                icon = null;
            }
        });
        $adp.on('stalled',function(){
            if(!loaded){
                loaded = 0;
                args.autoPlay = 1;
                this.load();
            }
        });
        $adp.on('error',function(){
            commitLogs({"type": "error", "log": "音频播放错误，错误码："+this.error.code});
            if((this.error.code == 4) && (this.getAttribute('src'))){
                if(args.callbackType == 1){
                    var btnG = $(icon).parent();
                    btnG.addClass('error');
                    btnG.attr('skipPlay', 1);
                    $.commFun.isPlayingAllTest();
                }
                else if(args.callbackType == 5){
                    $(icon).removeClass("loading");
                    pubArgu.listenVoiceObj = null;
                    isLoadingUrl = 0;
                }
            }
        });
    }
    //暂停监听器调用方法
    function playerPause(){
        if(args.callbackType == 1){
            $.iconAnimate.playSoundAniStop(icon);
        }
        else if(args.callbackType == 2){
            $.iconAnimate.listeningAniStop(icon);
        }
        else if(args.callbackType == 3){
            $.iconAnimate.dialoAniStop(icon);
        }
        else if(args.callbackType == 4){
            $.iconAnimate.lineAinStop(icon);
        }
        else if(args.callbackType == 5){
            $.iconAnimate.dictPlaySoundAinStop(icon);
        }
        else if(args.callbackType == 6){
            $.iconAnimate.dictlistenSoundAinStop(icon);
        }
    }
    //如果正在播放，则停止播放和动画
    function stopPlay(){
        if(args.callbackType == 1){
            queuePlayOff = 1; //跳到队列下一个时，禁止自动播放
        }
        if(!adper.paused){
            adper.pause();
            playerPause();
        }
        if(args.callbackType == 5 || args.callbackType == 6){
            pubArgu.listenVoiceObj = null;
            icon = null;
        }
    }
})(Zepto);