//接口转接调用
function bridge(funcName, jsonString, errorCallbackFun) {
    if(!funcName) return;
    try{ if(openBridgeFunList && !openBridgeFunList[funcName]) return; }catch(e){} //检查是否存在接口筛选列表，以决定是否执行接口
    jsonString = jsonString || "";
    console.log("【js调native】" + funcName + ": " + jsonString);
    console.log("isIOS:" + isIOS)
    if (isIOS) {
        console.log("is:" + isIOS)
        var jsonObj = {"action": funcName, "jsonString": jsonString};
        try{ window.webkit.messageHandlers.observe.postMessage(JSON.stringify(jsonObj)); }catch(e){
            if(errorCallbackFun) errorCallbackFun();
        }
    }
    else {
        try{
            if(jsonString){
                console.log("【js调native】3" + funcName + ": " + jsonString);
                dictcn[funcName](jsonString);
            }
            else {
                dictcn[funcName]();
            }
        }catch(e){
            if(errorCallbackFun) errorCallbackFun();
        }
    }
}


// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}


function popupDict(b) {
    var a = b;
    if(isJson(a)){
        a = JSON.stringify(a);
    }
    console.log("【js调native paste】-----");
    var errorCallbackFun = function(){
        popupDictCallback(a); //测试代码，标亮点击文本
    };
    bridge("popupDict", a, errorCallbackFun);
}
function popupDictCallback(a) {
    var b = parseJson(a);
    commitLogs({"type": "debug", "log": "[popupDictCallback] " + JSON.stringify(b)});
    if (typeof popupDictCall == "function") {
        popupDictCall(b)
    }
};
//开始测评
function beginEvaluating(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var key = jsonData.key || "";
    bridge("beginEvaluating", JSON.stringify({'uwid':uwid, 'key':key, 'successCallback':'onFinishEvaluating'}));
}
//结束测评回调函数
function onFinishEvaluating(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onFinishEvaluating] " + JSON.stringify(jsonData)});
    var uwid = jsonData.uwid || "";
    var score = parseInt(jsonData.score);
    if(uwid){
        $.commFun.refreshEvaIcon(uwid,score);
    }
}

function changeText(text){
	main.innerHTML = text;
}

/* 读写localStorage数据
 * setStorage方法参数：
 * {
 * "key": " "  //键值
 * "value":   //要保存的数据
 * }
 * getStorage方法参数：
 * {
 * "key": " "  //键值 (键值为 “ paperID_* ”时，是否直接返回一组筛选后的数据？)
 * "successCallback": ""   //回调函数名
 * }
 * getStorage方法回调函数 getAllEvaRes 参数：
 * {
 * "key": "pageID_Eva_*"  //键值
 * "value": {"pageID_Eva_uwid":"{'name':'', 'score':''}","pageID_Eva_uwid":"{}","pageID_Eva_uwid":"{}","pageID_Eva_uwid":"{}",...}  //json数据
 * }
 */
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value;
    if(isJson(jsonData.value)){
        value = JSON.stringify(jsonData.value) || "";
    }
    else {
        value = jsonData.value || "";
    }
    bridge("setItem", JSON.stringify({'key':key, 'value':value}));
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    bridge("getItem", JSON.stringify({'key':key, 'successCallback':successCallback}));
}


/* 添加生词本 addScb
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "source":"0/1",                            //标记单词收藏或例句收藏
 *     "keypath":"body.0.sense.6.cont.0.example.1",       //例句收藏中，例句数据的路径
 *     "parentuwid":"",       //例句收藏中，例句所属父级Uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var source = jsonData.source;
    var keypath = jsonData.keypath || "";
    var parentuwid = jsonData.parentuwid || "";
    bridge("addScb", JSON.stringify({'uwid':uwid,'source':source,'keypath':keypath ,'parentuwid':parentuwid,'successCallback':'onScbSuccess'}));

    // setTimeout(function(){ //测试代码
    //     onScbSuccess({"uwid":uwid, "in_scb": 1});
    // },500);
}
/* 
 * searchState
 * 参数格式json:
 * jsonData = {
    "searchState":1
 * }
 */
function searchState(jsonData){
    jsonData = parseJson(jsonData);
    var state = jsonData.searchState||0;
    bridge("searchStateChange",JSON.stringify({'searchState':state}));
}


/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onScbSuccess] " + JSON.stringify(jsonData)});
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    $.commFun.refreshStarIconStatus(uwid,in_scb);
}


/* 设置面板相关方法
 * settingDone参数格式json:
 * jsonData = {
 *     "fontSize": "10",          //字号
 *     "show_zhuyin": "1/0",          //是否显示注音
 *     "style_type": "1/2/3/4",       //版面样式
 *     "showTilde": "1/0",       //是否显示波浪线
 *     "showPjump": "1/0",       //是否显示原书另见
 * }
 */
// 完成设置方法
function settingDone(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[settingDone] " + JSON.stringify(jsonData)});
    $.commFun.settingRefresh(jsonData);
}
//设置面板开放native接口
//改变字体 
function changeFontSize(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[changeFontSize] " + JSON.stringify(jsonData)});
    $('html').css('font-size',jsonData.font_size+"px");
    // $.commFun.resizeSwiper();
}


////////////////////////////查字////////////////////////////////////////////////////////////////////////////
/* 查字或词组模块：
*   定义 查字方法 searchText
*/
////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字 【重刷页面】 */
function searchText(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || ""; //要跳转的单词的uwid
    var autoUwid = jsonData.autoUwid || ""; //变位词的情况
    var senseId = jsonData.senseId || ""; //跳转到第几条释义
    var pinyin = jsonData.pinyin || "";
    var location = jsonData.location || ""; //要跳转的位置id
    var extArgu = JSON.stringify({"senseId":senseId, "pinyin":pinyin, "location":location});
    bridge("searchText", JSON.stringify({"uwid":uwid,"autoUwid":autoUwid,"extArgu":extArgu}));
}

/* 查词组
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //要查询词组的uwid
 *     tplName:"",                              //模板名称
 *     successCallback:"onAjaxSuccess",
 *     failedCallback:"onAjaxFailed"
 * }
 */
function ajaxSearch(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var tplName = jsonData.tplName || "";
    bridge("ajaxSearch", JSON.stringify({'uwid':uwid,'tplName':tplName,'successCallback':"onAjaxSuccess",'failedCallback':"onAjaxFailed"}));

    // setTimeout(function(){
    //     onAjaxSuccess(jsonDD);
        // onAjaxFailed({"uwid": uwid});
    // },10);
}
/* 查词成功
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     htmlText:""                              //返回的html文本片段
 *     "scbStatus": {"65456595": 1, "65456596": 0, "65456597": 1, ...}       //例句收藏状态
 * }
 */
function onAjaxSuccess(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onAjaxSuccess] " + JSON.stringify(jsonData)});
    var uwid = jsonData.uwid || "";
    if(uwid){
        var $aim = $("[uwid='"+uwid+"']");
        if($aim.length){
            var tabBar = $aim.find(".tabBar")[0];
            if(tabBar.delayRf){
                clearTimeout(tabBar.delayRf);
                tabBar.delayRf = null;
            }
            tabBar.webReq = null;
            $.commFun.assePhrasePage($aim, jsonData.htmlText, jsonData.scbStatus);
        }
    }
}
/* 查词失败
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     tip:""                                  //提示信息
 * }
 */
function onAjaxFailed(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onAjaxFailed] " + JSON.stringify(jsonData)});
    var uwid = jsonData.uwid || "";
    var tip = jsonData.tip || "";
    if(uwid){
        var tabCon = $("[uwid='"+uwid+"']");
        var tabBar = tabCon.find(".tabBar")[0];
        tabBar.webReq = null;
        tabCon.addClass('failLoad');
        $(tabBar).one('click', function(){
            tabCon.removeClass('failLoad');
        });
    }
    if(tip) alert(tip);
}


//告知客户端用户选择文本
function tellSelectText(text){
    bridge("tellSelectText", JSON.stringify({'text':text}));
}
 //开放给native接口，设置是否关闭上下拉刷新
 function setPullToRefresh(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[setPullToRefresh] " + JSON.stringify(jsonData)});
    pubArgu.goWordLock = parseInt(jsonData.lock); //0 不锁定，1 锁定
 }

//开放给native接口，滑出webview时调用touchend事件
function swiperTouchMoveOut(){
    commitLogs({"type": "debug", "log": "[setPullToRefresh] "});
    var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody;
    if(swiperBody.width){
        var s = swiperPages[swiperBody.activeIndex];
        s.onTouchEnd(s);
    }
    else{
        swiperMain.onTouchEnd(swiperMain);
    }
}

/* 页面唤醒后更新状态方法update：
 * 参数格式json:
 * jsonData = {
 *     "scbStatus": {"65456595": 1, "65456596": 0, "65456597": 1, ...},      //收藏按钮状态
 *     "fontSize": "12",      //字体大小
 *     "simpleColor": "1/0",      //黑白配色
 * }
 */
function update(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[update] " + JSON.stringify(jsonData)});
    var scbStatus = jsonData.scbStatus;
    $.commFun.commSettingRefresh(jsonData); //通用设置更新页面方法
    if(scbStatus && isJson(scbStatus)){
        $.commFun.updateAllStarIconStatus(scbStatus); //刷新所有收藏按钮的状态
    }
}



/* 查看补充说明方法 viewAddsInstruction：
 * 参数格式json:
 * jsonData = {
 *     "showWay": "img/url/html/popupPanel...",      //展示方式，可扩展
 *     "imglist": ["xxx1.png","xxx2.png","xxx3.png"],      //展示方式，可扩展
 *     "index": "0",      //展示从第几个开始，没有默认为零
 *     "templateName": "abbreviation_explain",      //拼装页面时的模板名称
 *     "uwid": "", //html展示时，查词uwid
 *     "title": "", //html展示时，标题栏标题
 *     "extArgu": "{}",      //拼装页面时转发的数据
 * }
 */
 function viewAddsInstruction(jsonData){
    jsonData = parseJson(jsonData);
    var showWay = jsonData.showWay || "";
    var imglist = jsonData.imglist || "";
    var index = jsonData.index || 0;
    var templateName = jsonData.templateName || "";
    var uwid = jsonData.uwid || "";
    var title = jsonData.title || "说明";
    var senseId = jsonData.senseId || "";
    var extArgu = JSON.stringify({"senseId":senseId});
    bridge("viewAddsInstruction", JSON.stringify({"showWay":showWay, "imglist":imglist, "index":index, "title":title, "templateName":templateName, "uwid":uwid, "extArgu":extArgu}));
 }

 /* 向客户端请求播放链接（权限由客户端直接控制）
 * requestAudioUrl参数格式json:
 * jsonData = {
 *     "name": "xxx.mp3",      //音频的name
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "lang": "",      //lang
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "extArgu": {"classname": "playSound", "objIndex": "0/1/2/..."},      //回传定位参数
 * }
 * 成功回调函数onRequestAudioUrlSuccess参数格式json:
 * jsonData = {
 *     "url": "",      //音频的url
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "extArgu": {"classname": "playSound", "objIndex": "0/1/2/..."},      //回传定位参数
 * }
 * 失败回调函数onRequestAudioUrlFailed参数格式json:
 * jsonData = {
 *     "errCode": "1/2/3/...",      //约定的错误码(1为网络请求超时，2为音频文件丢失，3为无播放权限)
 *     "message": "音频文件丢失...",      //可供显示的错误提示
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "extArgu": {"classname": "playSound", "objIndex": "0/1/2/..."},      //回传定位参数
 * }
 */
 //请求播放链接方法
 function requestAudioUrl(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var type = jsonData.type || "";
    var lang = jsonData.lang || "";
    var uwid = jsonData.uwid || "";
    var extArgu = jsonData.extArgu || "";
    var url = jsonData.url || "";
    bridge("requestAudioUrl", JSON.stringify({"name":name, "type":type, "uwid":uwid, "lang":lang, "extArgu":extArgu, "successCallback":"onRequestAudioUrlSuccess", "failedCallback":"onRequestAudioUrlFailed","url":url}));
     // setTimeout(function(){ //测试代码
          // onRequestAudioUrlSuccess({"url":"./testAsset/kca05_kcb04.mp3", "type":type, "uwid":uwid, "extArgu":extArgu});
         // onRequestAudioUrlFailed({"type":type, "uwid":uwid, "extArgu":extArgu, "errCode":1, "message":"录音文件丢失"});
     // },1000);
 }
 //成功回调函数
 function onRequestAudioUrlSuccess(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onRequestAudioUrlSuccess] " + JSON.stringify(jsonData)});
    var url = jsonData.url;
    var uwid = jsonData.uwid;
    var type = jsonData.type;
    var extArgu = jsonData.extArgu;
    var objIndex = extArgu.objIndex;
    var $startNode = $("body");
    // console.log($startNode.find('[uwid="'+uwid+'"]').find('.'+extArgu.classname))
    if($startNode.find('[uwid="'+uwid+'"]').find('.'+extArgu.classname)[objIndex] == pubArgu.listenVoiceObj){ //对象比对成功，调用播放器开始播放
        var $lVO = $(pubArgu.listenVoiceObj);
        if(type == 1){
            $lVO.audioPlayer({"url":url, "autoPlay":1, "callbackType":5});
        }
        else if(type == 2){
            $lVO.audioPlayer({"url":url, "autoPlay":1, "callbackType":6});
        }
    }

 }
 //失败回调函数
 function onRequestAudioUrlFailed(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onRequestAudioUrlFailed] " + JSON.stringify(jsonData)});
    var uwid = jsonData.uwid;
    var type = jsonData.type;
    var errCode = jsonData.errCode;
    var message = jsonData.message;
    var extArgu = jsonData.extArgu;
    var objIndex = extArgu.objIndex;
    var $startNode = $("body");
    if($startNode.find('[uwid="'+uwid+'"]').find('.'+extArgu.classname)[objIndex] == pubArgu.listenVoiceObj){ //对象比对成功，开始错误处理
        if(type == 1){ //单词或例句发音
            if(errCode == 1 || errCode == 3){ //网络超时 or 没权限
                $(pubArgu.listenVoiceObj).removeClass('loading');
            }
        }
        else if(type ==2){ //语音评测录音发音
            if(errCode == 2){ //音频文件丢失
                $(pubArgu.listenVoiceObj).addClass('hidden');
            }
        }
        else {
            //
        }

        if(message) alert(message);
        pubArgu.listenVoiceObj = null;
    }
 }

 /* 重绘当前webview
 */
 function refreshWebView(){
    // console.log("refreshWebView!!!");
    bridge("refreshWebView");
 }

/* 弹出提示框
 * 方法参数：
 * {
 * "message": "" //Toast消息内容
 * }
 */
 function showToast(message){
    bridge("showToast", JSON.stringify({'message': message}));
 }

 /* 下载图片接口
 * requestImgPath方法参数：
 * {
 * "data": [{
 * "name": "" //图片name
 * "maxWidth": "320" //图片最大宽度(""空字符串代表没有)
 * "maxHeight": "" //图片最大高度(""空字符串代表没有)
 * },{},{},...],
 * "successCallback":"onRequestImgPathSuccess",         //成功回调函数
 * "failedCallback":"onRequestImgPathFailed",         //失败回调函数
 * }
 * onRequestImgPathSuccess方法参数：
 * {
 * "name": "" //图片name
 * "path": "" //图片路径
 * }
 * onRequestImgPathFailed方法参数：
 * {
 * "name": "" //图片name
 * }
 */
 function requestImgPath(jsonData){
    jsonData = parseJson(jsonData);
    if($.isArray(jsonData)){
        var jsonArray = [];
        for(var i=0,len=jsonData.length; i<len; i++){
            var val = jsonData[i];
            var name = val.name || "";
            var maxWidth = val.maxWidth ? val.maxWidth+"" : "";
            var maxHeight = val.maxHeight ? val.maxHeight+"" : "";
            if(name) jsonArray.push({"name":name, "maxWidth":maxWidth, "maxHeight":maxHeight});
        }
        bridge("requestImgPath", JSON.stringify({"data":jsonArray, "successCallback": "onRequestImgPathSuccess", "failedCallback":"onRequestImgPathFailed"}));
        // setTimeout(function(){
        //     $.each(jsonData, function(k,v){
                // onRequestImgPathSuccess({"name":v.name, "path":"./testAsset/"+v.name});
                // onRequestImgPathFailed({"name":v.name});
        //     });
        // },500);
    }
 }
 //请求图片成功回调函数
 function onRequestImgPathSuccess(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onRequestImgPathSuccess] " + JSON.stringify(jsonData)});
    var name = jsonData.name || "";
    var path = jsonData.path || "";
    if(name){
        var $img = $('img').filter("[name='"+ name +"']");
        if($img.length){
            $img.attr("src", path).removeClass("fail").addClass("success");
            // setTimeout(function(){
            //     if($img.is(":visible")) $.commFun.resizeSwiper($img);
            // },500);
        }
    }
 }
 //请求图片失败回调函数
 function onRequestImgPathFailed(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onRequestImgPathFailed] " + JSON.stringify(jsonData)});
    var name = jsonData.name || "";
    if(name){
        var $img = $('img').filter("[name='"+ name +"']");
        if($img.length){
            $img.attr("src", _resource_+"/images/default_fail.png").addClass("fail");
        }
    }
 }




/* 查看大图方法
 * viewBigImg方法参数：
 * {
 * "name": ["","",...] //当前面板中图片name数组
 * "showName": "" //标记显示数组中的哪个图片
 * }
 */
 function viewBigImg(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var showName = jsonData.showName || "";
    var successCallback = jsonData.successCallback || "";
    bridge("viewBigImg", JSON.stringify({'name': name, 'showName': showName, "successCallback": successCallback}));
 }
 //成功回调函数
 function onViewBigImgSuccess(){
    commitLogs({"type": "debug", "log": "[onViewBigImgSuccess] "});
    //更新加载失败的图片链接
    var arr = [];
    $('.img img.fail').each(function(){
        var $this = $(this);
        arr.push({"name": $this.attr("name")});
    });
    if(arr.length) requestImgPath(arr);
 }


 /* 开放给native接口：页面退入后台后冲突处理方法 pageSleep：
 */
function pageSleep(){
    commitLogs({"type": "debug", "log": "[pageSleep] "});
    if(window.clickConflictTest) clickConflictTest();
}

/*
 */
//跳转至纸书翻阅接口
function browseBook(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var page = jsonData.page || "";
    bridge("browseBook", JSON.stringify({'uwid': uwid, 'page': page}));
}

/* 听说、书写、易错 三个按钮点击弹窗接口
 * popupContentPanel方法参数：
 * {
 * "x": 0.22222222 //x轴坐标相对webview宽度的比例（左上角为原点）
 * "y": 0.33333333 //y轴坐标相对webview高度的比例（左上角为原点）
 * "key": "" //弹出面板数据key
 * "successCallback": ""
 * }
 * 成功回调函数（仅在有新评分时调用）：
 * {
 * "score": "" //新的评测分数
 * "key": "" //弹出面板数据key
 * }
 */
// 听说、书写、易错 三个按钮点击弹窗方法
function popupContentPanel(jsonData){
    jsonData = parseJson(jsonData);
    var x = jsonData.x || "";
    var y = jsonData.y || "";
    var key = jsonData.key || "";
    bridge("popupContentPanel", JSON.stringify({'x': x, "y": y, "key": key, "successCallback": "onPopupContentPanel"}));
    // setTimeout(function(){
    //     onPopupContentPanel({"score": 90, "key": key});
    // }, 1000);
}
//成功回调函数
function onPopupContentPanel(jsonData){
    jsonData = parseJson(jsonData);
    commitLogs({"type": "debug", "log": "[onPopupContentPanel] " + JSON.stringify(jsonData)});
    var score = jsonData.score || "";
    var key = jsonData.key || "";
    if(key && score >= 0){
        $.commFun.refreshPingfen(key, score);
    }
}


/* 发送消息 showLog
 * showLog
 * {
 * "log": "..."   //log内容
 * }
 */
 function showLog(jsonData){
    jsonData = parseJson(jsonData);
    var log = jsonData.log || "";
    bridge("showLog", JSON.stringify({'log': log}));
 }

// window.onerror = function(msg,url,l) {
//     var data = {
//         'message': msg,
//         'url': url,
//         'line': l
//     };
//     // showLog({"log": "JS_ERROR: " + JSON.stringify(data)});
//     // testInfo.innerText += JSON.stringify(data);
//     commitLogs({"type": "error", "log": JSON.stringify(data)});
//     return true;
// };

/* 提交日志 commitLogs
 * showLog
 * {
 * "type": "user / error / debug"   //日志类型：行为 / 错误 / debug
 * "log": "..."   //log内容
 * }
 */
 function commitLogs(jsonData){
    jsonData = parseJson(jsonData);
    var type = jsonData.type || "";
    var log = jsonData.log || "";
    bridge("commitLogs", JSON.stringify({'type': type, 'log': log}));
 }

// testInfo.innerText = "Waring: ";
// $("body").on("touchstart",function(e){
//     // testInfo.innerText += e.target.tagName + " classname: "+ e.target.className+ " id: "+ e.target.id + " / ";
// });


//开放给native接口： 获取页面元素的高度
function getDomOffset(dom){
    var offset = $(dom).offset();
    returnDomOffset(offset);
    return offset;
}
//返回页面高度给native
function returnDomOffset(offset){
    bridge("returnDomOffset", JSON.stringify({'offset': offset}));
}