var pubArgu = {
	swiperPages: [],
	swiperMain: null,
	tagBar: null,
	swiperBody: null,
	goWordLock: 0, //是否停止上下词跳转
	headHeight: null,
	windowHeight: null,
	tagBarHeight: null,
	showBrowserMenu: null, //标记浏览器长按菜单是否已显示
	listenVoiceObj: null, //全局发音对象
}; //公用的全局变量

$(function(){
	function fixPageHeight(){
		pubArgu.windowHeight = document.documentElement.clientHeight;
	    $('#swiperMain').css('height', pubArgu.windowHeight);
	}
	init();
	function init(){
		FastClick.attach(document.body);
		fixPageHeight();
		
		bindClickEvent(); //绑定页面元素点击事件

		//文本搜索初始化
		$('#searchText').searchText({"hideIcon": $('.fixIconBtn'), "rootNode": $(".main")[0], "specharRexpType": 2, "foldLabelList": ["sections","hideExpSen"], "coatWordLabel": "tilde"});

		tellNativeUserSelText();//每次用户选择文本改变时，告知客户端选择的文本内容

		//捕获阶段全局阻挡多点触控
		document.addEventListener('touchstart',function(e){
			if(e.touches.length > 1) e.stopPropagation();
		},true);

		// $(window).on("load",function(){
		// 	console.log("load!!!")
		// });

	}

	//每次用户选择文本改变时，告知客户端选择的文本内容
	function tellNativeUserSelText(){
		var delayClickable;
		document.onselectionchange = function(){
			if($.searchText.isSerTextIng()) return;
			var str = window.getSelection().toString();
		    tellSelectText(str);
		    if(delayClickable){
		    	clearTimeout(delayClickable);
		    	delayClickable = null;
		    }
		    if(str.length){
		    	pubArgu.showBrowserMenu = 1;
		    }
		    else {
		    	delayClickable = setTimeout(function(){
		    		pubArgu.showBrowserMenu = 0;
		    		delayClickable = null;
		    	},400);
		    }
		}
	}
	
	//绑定页面元素点击事件
	function bindClickEvent(){
		var $con = $('#main');
		//播放声音按钮点击事件
		$con.on('click','.playSound',function(e){
			e.stopPropagation();
			if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
				clickConflictTest();
				pubArgu.listenVoiceObj = this;
				var $this = $(this);
				$this.addClass("loading");
				var jsonD = {"name": $this.attr("name"), "lang": $this.attr("lang"), "type": 1, "uwid": $this.attr("uwid"), "classname": "playSound", "extArgu": {"classname": "playSound", "objIndex": "0"}};
				requestAudioUrl(jsonD);
			}
			else { //当前按钮正处于激活状态
				if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
					$.audioPlayer.stopPlay();
				}
			}
		});
		//添加收藏图标点击事件
		$con.on('click','.addStar',function(e){
			e.stopPropagation();
			var $this = $(this);
			var uwid = $this.parent().attr('uwid');
			if(uwid == pageID){
				addScb({"uwid": uwid, "source": "0"});
			}
			else {
				addScb({"uwid": uwid, "source": "1", "keypath":$this.attr('keypath')});
			}
		});
	}

	//冲突检测方法
	function clickConflictTest(){
		//是否正在播放声音检测
		if(pubArgu.listenVoiceObj){
			$(pubArgu.listenVoiceObj).removeClass('loading'); //去除loading
			$.audioPlayer.stopPlay(); //停止播放器及对应动画
		}
	}
	window.clickConflictTest = clickConflictTest;

});
