;(function($){
    var args;
    $.jumpPosition = ({
        init:function(options){ //组件初始化
            init(options);
        },
        jumpProcedure:function($aim){ //继续处理跳转
            jumpProcedure($aim);
        },
    });
    $.jumpPosition.defaults = {
        "senseClassName" : ["cont-item-layout","sub-cont-item-layout","subsensedef"], //释义层级类名
        "jumpOffset" : 50, //跳转目标时的偏移值
    };
    //初始化
    function init(options){
        args = $.extend({}, $.jumpPosition.defaults, options);
        connectWord = parseJson(connectWord);
        jumpProcedure();
    }
    //跳转执行流程
    function jumpProcedure($aim){
        var uwid = shiftAutoUwid();
        if(uwid){
            parseAutoUwid(uwid); //解析uwid
        }
        else {
            otherTypeJump($aim); //处理其他跳转
        }
    }

    //处理其他跳转
    function otherTypeJump($aim){
        //处理connectWord跳转
        if(connectWord) {
            if(connectWord.word){
                if(isCJK(connectWord.word) && pageState.showCh == "0"){
                    showToast("您已关闭“中文显示”，请打开后重试！");
                    return;
                }
                setTimeout(function(){
                    $.searchText.jumpWords(connectWord.word, connectWord.belong);
                    connectWord = {};
                },100);
                return;
            }
        }

        //处理释义部分的跳转
        if(senseJump($aim)) return;
        
        //如果以上都没有跳转，执行备选跳转
        alternativeJump($aim);
    }

    //特殊词典备选跳转方法
    function alternativeJump($aim){
        if($aim){
            setTimeout(function(){
                $.commFun.jumpToAim($aim);
            },100);
        }
        var $sections = $(".sections");
        var $first = $sections.eq(0);
        var $last = $sections.eq(-1);
        $first.addClass("show").trigger("showMe");
        $last.addClass("show").trigger("showMe");
        // $.commFun.resizeSwiper($sections);
    }

    //处理释义部分的跳转
    function senseJump($aim){
        extArgu = parseJson(extArgu) || {};
        if(extArgu.senseId || extArgu.pinyin || extArgu.location){
            var s = pubArgu.swiperMain;
            if(extArgu.pinyin){
                var id = $.commFun.pyToIndex(extArgu.pinyin);
                pubArgu.swiperBody.slideTo(id, 0, true);
                s = pubArgu.swiperPages[id];
                extArgu.pinyin = null;
            }
            if(extArgu.location){
                var $location = $("#"+extArgu.location);
                if(!extArgu.senseId){ //没有senseId
                    executeJump($location, $location); //执行跳转
                }
                else { //有senseId
                    if(extArgu.location == "sense"){
                        if($aim){
                            $aim = senseIdSearch($aim);
                        }
                        else {
                            $aim = $location;
                            $aim = senseIdSearch($aim);
                        }
                        if($aim.length) {
                            $aim.before('<div id="jumpMark"></div>');
                            setTimeout(function(){
                                $("#jumpMark").remove();
                            }, 3200);
                        }
                        executeJump($aim, $location); //执行跳转
                    }
                    else { //其他位置的senseId跳转
                        extArgu.senseId = parseJson(extArgu.senseId);
                        $aim = $location.find(".tabContent").children().eq(extArgu.senseId[0]-1);
                        executeJump($aim, $location); //执行跳转
                    }
                }
                extArgu.location = null;
            }
            return true;
        }
        return false;
    }

    //执行跳转
    function executeJump($aim, $location){
        if(!$location.hasClass("show")){
            $location.addClass("show");
            setTimeout(function(){
                // $.commFun.resizeSwiper($location);
                $.commFun.jumpToAim($aim, args.jumpOffset);
            },300);
        }
        else {
            $.commFun.jumpToAim($aim, args.jumpOffset);
        }
    }

    //遍历senseId，逐层查询目标
    function senseIdSearch($aim){
        extArgu.senseId = parseJson(extArgu.senseId);
        if($.isArray(extArgu.senseId)){
            for(var i=0,len=extArgu.senseId.length; i<len; i++){
                $aim = $aim.find("."+args.senseClassName[i]+extArgu.senseId[i]);
            }
        }
        else {
            $aim = $aim.find("."+args.senseClassName[0]+extArgu.senseId);
        }
        extArgu.senseId = null;
        return $aim;
    }

    //解析uwid
    function parseAutoUwid(uwid){
        var $dom = $("[uwid='"+uwid+"']");
        var domType = judgeDomType($dom); //获取元素class类型
        if(domType == "children"){
            openChildren($dom); //打开词组
        }
        else {
            if(auto_uwid.length){ //如果auto_uwid数组还有元素，则开始下一次流程
                jumpProcedure();
                return;
            }
            if(domType == "example"){
                jumpExample($dom); //跳转到例句
            }
            else if(domType == "cimu"){
                jumpCimu($dom); //跳转到词目
            }
        }
    }

    //跳转到例句
    function jumpExample(aim){
        var sections = aim.parents('.sections');
        sections.addClass("show");
        setTimeout(function(){
            // $.commFun.resizeSwiper(sections);
            $.commFun.jumpToAim(aim.parent(), args.jumpOffset);
        },200);
    }

    //跳转到词目
    function jumpCimu($dom){
        alternativeJump($dom);
    }

    //打开词组
    function openChildren(aim){
        if(!aim.hasClass('show')){ //闭合标签
            setTimeout(function(){
                if(aim.attr('hascon') == "0") $.commFun.jumpToAim(aim); //300ms后，词组依然没有内容，则跳转到词组位置
            },300);
            $.commFun.setFirstLoad(1); //点开词条并载入后，需要继续跳转页面
            $.commFun.tabBarClick.call(aim.find('.tabBar')[0]);
        }
        else { //已经打开
            if(aim.attr('hascon') == "1"){ //已经有内容，直接跳转
                jumpProcedure(aim);
            }
            else { //加载失败，或正在加载中
                $.commFun.jumpToAim(aim);
            }
        }
    }

    //获取元素class类型
    function judgeDomType($dom){
        if($dom.hasClass("children")) return "children";
        if($dom.hasClass("exampleIcon")) return "example";
        if($dom.hasClass("cimu")) return "cimu";
    }

    //读取auto_uwid
    function shiftAutoUwid(){
        var uwid;
        if($.isArray(auto_uwid)){
            uwid = auto_uwid.shift();
        }
        return uwid;
    }

    //检测是否为中文
    function isCJK(str){
        var re = /[\u1100-\u11f9\u3041-\u30ff\u3104-\u312a\u3130-\u318e\u3400-\u4db5\u4e00-\u9fa5\uac00-\ud7a3\uf900-\ufa2c\uff66-\uff9e]/; 
        if(re.test(str)) return true;
        return false; 
    }
    
})(Zepto);