var pubArgu = {
	swiperPages: [],
	swiperMain: null,
	tagBar: null,
	swiperBody: null,
	goWordLock: 0,
	headHeight: null,
	windowHeight: null,
	windowWidth: null,
	tagBarHeight: null,
	showBrowserMenu: null, //标记浏览器长按菜单是否已显示
	listenVoiceObj: null, //全局发音对象
}; //公用的全局变量

$(function(){
	var curIndex;
	init();
	function init(){
		initTimeLog += " / 开始执行init方法: " + new Date().getTime();
		FastClick.attach(document.body);

		$.commFun.fixPageHeight();


		bindClickEvent(); //绑定页面元素点击事件
		//文本搜索初始化
		// $('#searchText').searchText({"rootNode": $(".main")[0], "foldLabelList": ["sections","hideExpSen"], "coatWordLabel": "tilde"});
		$('#searchText').searchText({"hideIcon": $('.fixIconBtn'), "rootNode": $(".main")[0], "specharRexpType": 2, "foldLabelList": ["sections","hideExpSen"], "iconsConflictFun": tagMenuConflict, "coatWordLabel": "tilde"});
		
	
		tellNativeUserSelText();//每次用户选择文本改变时，告知客户端选择的文本内容

		//浏览器窗口改变时，重置swiper
		$(window).on("resize",$.commFun.windowSizeSwiper);
		
		//捕获阶段全局阻挡多点触控
		// document.addEventListener('touchstart',function(e){
		// 	if(e.touches.length > 1) e.stopPropagation();
		// },true);

		foldLongContent(); //折叠过长的内容-监听器

		$.jumpPosition.init();

		refreshImgUrl(); //更新网络图片链接

		initTimeLog += " / 初始化完成: " + new Date().getTime();
		commitLogs({"type": "debug", "log": "【查字结果页】[页面初始化] " + initTimeLog});

        //subdef为空颜色设为黑底
		$('abbr').each(function(){
            if ($(this).attr('subdef') == ''){
                $(this).css('color','#999999');
            }
		});

	}

	//绑定页面元素点击事件
	function bindClickEvent(){
		var $con = $("#main").parent();
		//fullname标签点击弹出补充说明
		$con.on('click','fullname',function(e){
			e.stopPropagation();
			var $this = $(this);
			viewAddsInstruction({"showWay":"popupPanel", "uwid": $this.attr("subuwid")});
			commitLogs({"type": "user", "log": "【查字结果页】点击fullname标签文本，查看补充说明。"});
		});

		//添加收藏图标点击事件
		$con.on('click','.addStar',function(e){
			e.stopPropagation();
			var $this = $(this);
			var uwid = $this.parent().attr('uwid');
			if(uwid == pageID){
				addScb({"uwid": uwid, "source": "0"});
			}
			else {
				addScb({"uwid": uwid, "source": "1", "keypath":$this.attr('keypath')});
			}
		});

		$con.on('click','abbr',function(e){
			e.stopPropagation();
			var subdef = $(this).attr('subdef');
			if (subdef) {
				createMeaningPanel(subdef, this);
			}
		});

		//er跳转标签点击事件
		$con.on('click','er',function(e){
			e.stopPropagation();
			var $this = $(this);
			var uwid = $this.attr("subuwid");
			if(uwid == pageID){ //本页跳转
				extArgu = {"senseId":$(this).attr("index"), "location": $this.attr("location")};
	            $.jumpPosition.jumpProcedure();
			}
			else { //查词跳转
				searchText({"uwid": uwid, "senseId": $this.attr("index"), "location": $this.attr("location")});
			}
			commitLogs({"type": "user", "log": "【查字结果页】点击er标签按钮，跳转词条。"});
		});
		// pjump 标签跳转
		$con.on('click','pjump',function(e){
			e.stopPropagation();
			browseBook({"uwid": $(this).attr("subuwid"), "page": $(this).attr("page")});
			commitLogs({"type": "user", "log": "【查字结果页】点击pjump标签按钮，跳转纸书翻阅。"});
		});
		// fubiao 标签跳转
		$con.on('click','fubiao',function(e){
			e.stopPropagation();
			browseBook({"page": $(this).attr("page")});
			commitLogs({"type": "user", "log": "【查字结果页】点击fubiao标签按钮，跳转纸书翻阅附表。"});
		});


		//tabBar点击事件
		// $con.on("click",".tabBar.mulCol",function(e){
		// 	e.stopPropagation();
		// 	tabBarClick(this);
		// 	commitLogs({"type": "user", "log": "【查字结果页】点击tabBar，打开/折叠栏目。"});
		// });
		//折叠例句按钮点击事件
		$(".hideExpSenBtn").on('click',function(e){
			e.stopPropagation();
			var $This = $(this);
			$This.parent().parent().toggleClass('hideExpSen');
			commitLogs({"type": "user", "log": "【查字结果页】点击例证按钮，显示/隐藏例证。"});
		});

		//点击图片放大
		var nameArr = [];
		$('.imgArea img').each(function(){
			nameArr.push($(this).attr('name'));
		});
		$con.on('click','.imgArea img.success',function(e){
			e.stopPropagation();
			viewBigImg({"name": nameArr, "showName": $(this).attr('name'), "successCallback": "onViewBigImgSuccess"});
			commitLogs({"type": "user", "log": "【查字结果页】点击看大图。"});
		});
		//点击图片，重新加载
		$con.on('click','.imgArea img.fail',function(e){
			e.stopPropagation();
			var $this = $(this);
			var maxWidth = $(this).width();
			var arr = [{"name": $this.attr("name"), "maxWidth": maxWidth}];
			requestImgPath(arr);
			$this.attr("src", _resource_+"/images/default_loading.png").removeClass("fail");
			commitLogs({"type": "user", "log": "【查字结果页】点击加载失败的图片，重新加载该图片。"});
		});
		//点击tupian标签，显示图片
		$con.on('click','tupian',function(e){
			e.stopPropagation();
			var showName = $(this).attr('iname');
			viewBigImg({"name": [showName], "showName": showName});
			commitLogs({"type": "user", "log": "【查字结果页】点击参见原书图片的‘**图片’文字，查看该图片大图。"});
		});

		//头部三个按钮点击事件
		$con.on('click','.pingfen-table>div img',function(e){
			e.stopPropagation();
			var $section = $(this).parent().parent();
			var offset; //保存位置信息
			// if($section.children(".score").length){ //根具有无分数，确定弹出框的纵向位置
			// 	offset = $section.offset();
			// }
			// else {
				offset = this.getBoundingClientRect();
			// }
			var jsonData = {"x": (offset.left + offset.width / 2) / pubArgu.windowWidth, "y": (offset.top + offset.height + 5) / pubArgu.windowHeight, "key": $section.prop("className")}; //计算坐标比例及获取类名
			commitLogs({"type": "user", "log": "【查字结果页】点击头部听说/读写/易错三个按钮中的"+ jsonData.key +"按钮。"});
			popupContentPanel(jsonData);
		});

		//为折叠按钮绑定点击事件
		$con.on("click", ".foldBtn", function(e){
			e.stopPropagation();
			var $this = $(this);
			if(!$this.hasClass("unfold")){
				$this.addClass("unfold");
				$this.prev().removeClass("close_text");
				commitLogs({"type": "user", "log": "【查字结果页】点击‘展开更多’按钮，查看隐藏的内容。"});
			}
			else {
				$this.removeClass("unfold");
				$this.prev().addClass("close_text");
				commitLogs({"type": "user", "log": "【查字结果页】点击‘收起’按钮，隐藏多余的内容。"});
			}
		});

		//播放声音按钮点击事件
		$con.on('click','.playSound',function(e){
			e.stopPropagation();
			if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
				clickConflictTest();
				pubArgu.listenVoiceObj = this;
				var $this = $(this);
				$this.addClass("loading");
				var objIndex = $.inArray(this, $this.parents('.pron-box').find(".playSound"));
				if (objIndex==-1) {
                    objIndex = $.inArray(this, $this.parents('.pospron').find(".playSound"));
                    if(objIndex==-1) {
                        objIndex=0;
                    }
				}
				var jsonD = {"name": $this.attr("name"), "lang": $this.attr("lang"), "type": 1,
				"uwid": $this.attr("uwid"), "extArgu": {"classname": "playSound", "objIndex": objIndex}, "url":$this.attr("url")};
				requestAudioUrl(jsonD);
				commitLogs({"type": "user", "log": "【查字结果页】点击播放单词声音按钮（开始播放）"});
			}
			else { //当前按钮正处于激活状态
				if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
					$.audioPlayer.stopPlay();
					commitLogs({"type": "user", "log": "【查字结果页】点击播放单词声音按钮（停止播放）"});
				}
			}
		});

		//播放场景音按钮点击事件
		$con.on('click','.changjin',function(e){
			e.stopPropagation();
			if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
				clickConflictTest();
				pubArgu.listenVoiceObj = this;
				var $this = $(this);
				$this.addClass("loading");
				var jsonD = { "name": $this.attr("name"), "lang": $this.attr("lang"), "type": 1, "uwid": $this.attr("uwid"), "extArgu": {"classname": "changjin", "objIndex": 0 }};
				requestAudioUrl(jsonD);
				commitLogs({"type": "user", "log": "【查字结果页】点击播放场景音按钮（开始播放）"});
			}
			else { //当前按钮正处于激活状态
				if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
					$.audioPlayer.stopPlay();
					commitLogs({"type": "user", "log": "【查字结果页】点击播放场景音按钮（停止播放）"});
				}
			}
		});

        //语音测评按钮点击事件
        $con.on('click','.recordSound',function(e){
            e.stopPropagation();
            clickConflictTest();
            beginEvaluating({"uwid": $(this).attr('uwid'), "key": $(this).attr("key")});
        });

        //播放录音按钮点击事件
        $con.on('click','.listenSound',function(e){
            e.stopPropagation();
            if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
                clickConflictTest();
                pubArgu.listenVoiceObj = this;
                var $this = $(this);
                var $prev = $this.prev();
                var uwid = $prev.attr("uwid");
                var name = $prev.attr("key");
                var objIndex = 0;
                var jsonD = {"name": name, "type": 2, "uwid": uwid, "extArgu": {"classname": "listenSound", "objIndex": objIndex}};
                requestAudioUrl(jsonD);
            }
            else { //当前按钮正处于激活状态
                if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
                    $.audioPlayer.stopPlay();
                }
            }
        });


        //--------------------右下角菜单区点击事件----------------------
		var $fixIconBtn = $('.fixIconBtn');
		//"更多"（用户菜单）按钮点击事件
		$fixIconBtn.on('click','#userMenu',function(e){
			e.stopPropagation();
			var fixIconBtn = $(this).parent();
			fixIconBtn.toggleClass("active");
			if(fixIconBtn.hasClass("active")){
				this.timeout = setTimeout(function(){
					tagMenuIconClick();
					this.timeout = null;
				},200);
			}
			else {
				tagMenuConflict();
			}
		});
		//右下角标签菜单点击事件
		$fixIconBtn.on('click','#tagMenu>div',function(e){
			e.stopPropagation();
			var $this = $(this);
			if(!$this.hasClass('active')){
				$('#tagMenu div.active').removeClass('active');
				$this.addClass('active');
			}
			var aim = $('#'+$this.attr('aim'));
			aim.addClass('show');
			// $.commFun.resizeSwiper(aim);
			$.commFun.jumpToAim(aim);
			var parents = $this.parent().parent();
			parents.addClass('hasClick');
			setTimeout(function(){
				tagMenuIcon.className = "";
				parents.removeClass('hasClick active showTagMenu');
			},300);
		});
		//设置菜单按钮点击事件
		$fixIconBtn.on('click','#userSetting',function(e){
			e.stopPropagation();
			tagMenuConflict();
			$(this).parent().removeClass('active').addClass('hideAway');
			openSettingPanel();
		});
		//tagMenuIcon按钮点击事件
		$fixIconBtn.on('click','#tagMenuIcon',function(e){
			e.stopPropagation();
			tagMenuIconClick();
		});
	}

	//标签栏点击事件
	function tabBarClick(This){
		var $This = $(This);
		var $parent = $This.parent();
		$parent.toggleClass('show');
		if($parent.hasClass("show") && $parent.attr("foldup") == "0"){
			$parent.trigger("showMe");
		}
	}
	
	//每次用户选择文本改变时，告知客户端选择的文本内容
	function tellNativeUserSelText(){
		var delayClickable;
		document.onselectionchange = function(){
			if($.searchText.isSerTextIng()) return;
			var str = window.getSelection().toString();
		    tellSelectText(str);
		    if(delayClickable){
		    	clearTimeout(delayClickable);
		    	delayClickable = null;
		    }
		    if(str.length){
		    	pubArgu.showBrowserMenu = 1;
		    }
		    else {
		    	delayClickable = setTimeout(function(){
		    		pubArgu.showBrowserMenu = 0;
		    		delayClickable = null;
		    	},400);
		    }
		}
	}

	//tagMenu 冲突及关闭
	function tagMenuConflict(){
		if(userMenu.timeout){
			clearTimeout(userMenu.timeout);
			userMenu.timeout = null;
		}
		tagMenuIcon.className = "";
		$('.fixIconBtn').removeClass('showTagMenu');
	}

	//tagMenuIcon按钮点击事件绑定方法
    function tagMenuIconClick(){
        var $this = $(tagMenuIcon);
        var $parent = $this.parent();
        if($this.hasClass('active')){
            $this.removeClass('active');
            $parent.removeClass('showTagMenu');
        }
        else {
            $this.addClass('active');
            $parent.addClass('showTagMenu');
            var id = $.commFun.testActiveTag();
            if(id != curIndex){
                curIndex = id;
                $('#tagMenu .active').removeClass('active');
                $('#tagMenu div').eq(curIndex).addClass('active');
            }
            $('.main-container').one('touchstart',function(){
                $parent.removeClass('active showTagMenu');
                tagMenuIcon.className = "";
            });
        }
    }

	//更新网络图片链接
	function refreshImgUrl(){
		//更新img图片链接
		var arr = [];
		var maxWidth = $('.imgArea img').width()*2;
		$('.imgArea img').each(function(){
			var $this = $(this);
			arr.push({"name": $this.attr("name"), "maxWidth": maxWidth});
		});
		if(arr.length) requestImgPath(arr);
	}

	//折叠过长的内容
	function foldLongContent(){
		$("#phrase").one("showMe", function(){
			var $this = $(this);
			setTimeout(function(){
				$this.find(".wordsContent").each(function(){
					var $this = $(this);
					var needfold = checkIsLongContent($this); //检测是否为长内容
					if(needfold){ //是长内容，折叠，并添加展开按钮
						$this.addClass("close_text");
						$this.after('<div class="foldBtn"></div>');
					}
				});
			}, 200);
			$this.attr("foldup", "1"); //标记为已折叠
		});
	}

	//检测是否为长内容
	function checkIsLongContent($aim){
		var lineHeight = parseFloat($aim.css("line-height").split("px")[0]) + 10;
		var totalHeight = $aim.height();
		var lineCount = Math.round(totalHeight / lineHeight);		
		return lineCount > 2;
	}

	//冲突检测方法
	function clickConflictTest(){
		//是否正在播放声音检测
		if(pubArgu.listenVoiceObj){
			$(pubArgu.listenVoiceObj).removeClass('loading'); //去除loading

			if($.audioPlayer.isHandleMe(pubArgu.listenVoiceObj)){ //如果播放器正在处理当前播放对象的请求
				$.audioPlayer.autoPlay(0); //停止自动播放，避免有音频正在解码而无法停止播放，出现错误
			}
			$.audioPlayer.stopPlay(); //停止播放器及对应动画
		}
	}
	window.clickConflictTest = clickConflictTest;


	//显示弹框，写入内容
	var xlimt = 12; //水平方向弹框限界
	var $cWPopPanel = $("#cWPopPanel");
	function createMeaningPanel(data, dom){
		$cWPopPanel.addClass("show");
		//写入内容
		$cWPopPanel.find(".panelContent").html(data);
		var pivot = getHighlighterPivot(dom);
		var pos = dom.getBoundingClientRect();
		var panelWidth = $cWPopPanel.width(), panelHeight = $cWPopPanel.height();
		//确定弹窗x轴位置
		var xpos = pos.left + pos.width / 2 - panelWidth / 2; //弹窗x坐标
		var arrowXPos = panelWidth / 2 - 10; //箭头x坐标
		var xMax = pubArgu.windowWidth - xlimt - panelWidth;
		if(xpos < xlimt){
			arrowXPos -= xlimt - xpos;
			xpos = xlimt;
		}
		else if (xpos > xMax){
			arrowXPos -= xMax - xpos;
			xpos = xMax;
		}
		var arrowXPos; //箭头x坐标
		//确定弹窗y轴坐标
		var ypos, yAvg = (pivot.topPoint.y + pivot.bottomPoint.y) / 2; //y轴坐标， y轴中点比例
		// console.log(yAvg)
		if(yAvg < 0.5){
			arrowXPos = pivot.bottomPoint.x * pubArgu.windowWidth - xpos - 10; //箭头x坐标
			ypos = pivot.bottomPoint.y * pubArgu.windowHeight + 10;
			$cWPopPanel.addClass("reverse");
		}
		else {
			arrowXPos = pivot.topPoint.x * pubArgu.windowWidth - xpos - 10; //箭头x坐标
			ypos = pivot.topPoint.y * pubArgu.windowHeight - panelHeight - 10;
		}
		$cWPopPanel.css({"top": ypos, "left": xpos});
		$cWPopPanel.find(".arrowIcon").css({"left": arrowXPos});

		$cWPopPanel.on("touchstart", function(e){
			e.preventDefault();
		});
		//触摸即隐藏
		$(document).on("touchstart", touchHideCWPopPanel);
	}

	//触摸隐藏弹窗面板
	function touchHideCWPopPanel(e){
		if(!$(e.target).closest("#cWPopPanel").length){ //触摸元素不在面板范围内
			$cWPopPanel.removeClass("show reverse");
			$(document).off("touchstart", touchHideCWPopPanel); //移除监听器
		}
	}

	//判定选区箭头中心点
	function getHighlighterPivot(highlighter){
		var lastX, newX, ttNode; //上一个位置的X坐标
		var range = document.createRange();
		var textNode = highlighter.firstChild;
		var startOffset = 0; //选区起点
		var offsetInitial = 0; //选区偏移减少值
		var topPoint = {}, bottomPoint = {}; //上下中心点

		//遍历节点, 按行归纳节点
		for(var i = 1, len = highlighter.innerHTML.length; i <= len; i++){
			//清空上一个选取节点
			if(ttNode){
				ttNode.outerHTML = ttNode.innerHTML;
	            highlighter.normalize();
			}

			//创建新选取节点
			createNewSelNode(range, textNode, startOffset, i - offsetInitial, "tt");
	        ttNode = highlighter.getElementsByTagName("tt")[0];
			newX = ttNode.getBoundingClientRect().right;

	        if(lastX && newX <= lastX){ //如果存在旧坐标，且新坐标小于等于旧坐标，说明存在换行
	        	//清除当前选取节点
	        	ttNode.outerHTML = ttNode.innerHTML;
	            highlighter.normalize();

	            //创建被固化的节点
	            createNewSelNode(range, textNode, startOffset, i - offsetInitial - 1, "gt");
	            var nodeArr = highlighter.getElementsByTagName("gt");
	            textNode = nodeArr[nodeArr.length - 1].nextSibling;

				//重置选区起点
				offsetInitial = i - 1;
				//创建新选取节点
				createNewSelNode(range, textNode, startOffset, i - offsetInitial, "tt");
		        ttNode = highlighter.getElementsByTagName("tt")[0];
				newX = ttNode.getBoundingClientRect().right;
	        }
	        lastX = newX;
		}
		ttNode.outerHTML = "<gt>" + ttNode.innerHTML + "</gt>";
		//遍历完成后，检查是否存在换行，完成定位标签创建
		var gtNodeArr = highlighter.getElementsByTagName("gt");
		if(gtNodeArr.length > 1){ //有多个gt标签，说明存在换行
			var pos = gtNodeArr[0].getBoundingClientRect();
			topPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
			topPoint.y = pos.top / pubArgu.windowHeight;
			//选择后一个选区进行定位
			pos = gtNodeArr[gtNodeArr.length - 1].getBoundingClientRect();
			bottomPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
			bottomPoint.y = pos.bottom / pubArgu.windowHeight;
		}
		else { //不存在换行，以当前标签为定位中心点
			var pos = gtNodeArr[0].getBoundingClientRect();
			topPoint.x = (pos.left + pos.width / 2) / pubArgu.windowWidth;
			topPoint.y = pos.top / pubArgu.windowHeight;
			bottomPoint.x = topPoint.x;
			bottomPoint.y = pos.bottom / pubArgu.windowHeight;
		}
		//清除gt选区
		do {
			var node = gtNodeArr[0];
			node.outerHTML = node.innerHTML;
		} while(gtNodeArr[0]);
		highlighter.normalize();

		return {"topPoint": topPoint, "bottomPoint": bottomPoint};
	}
	//创建新选取节点
	function createNewSelNode(range, textNode, startOffset, endOffset, tagname){
		range.setStart(textNode, startOffset);
		range.setEnd(textNode, endOffset);
		var newTag = document.createElement(tagname);
	    range.surroundContents(newTag);
	}
});